<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XCumaServerSecurityProfile StructType
 * @subpackage Structs
 */
class XCumaServerSecurityProfile extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The securityMode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $securityMode;
    /**
     * The transportType
     * Meta information extracted from the WSDL
     * - default: TCP+UDP
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $transportType;
    /**
     * The serverIpHostName
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 255
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $serverIpHostName;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $description;
    /**
     * The x509SubjectName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $x509SubjectName;
    /**
     * Constructor method for XCumaServerSecurityProfile
     * @uses XCumaServerSecurityProfile::setName()
     * @uses XCumaServerSecurityProfile::setSecurityMode()
     * @uses XCumaServerSecurityProfile::setTransportType()
     * @uses XCumaServerSecurityProfile::setServerIpHostName()
     * @uses XCumaServerSecurityProfile::setDescription()
     * @uses XCumaServerSecurityProfile::setX509SubjectName()
     * @param string $name
     * @param string $securityMode
     * @param string $transportType
     * @param string $serverIpHostName
     * @param string $description
     * @param string $x509SubjectName
     */
    public function __construct($name = null, $securityMode = null, $transportType = 'TCP+UDP', $serverIpHostName = null, $description = null, $x509SubjectName = null)
    {
        $this
            ->setName($name)
            ->setSecurityMode($securityMode)
            ->setTransportType($transportType)
            ->setServerIpHostName($serverIpHostName)
            ->setDescription($description)
            ->setX509SubjectName($x509SubjectName);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCumaServerSecurityProfile
     */
    public function setName($name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get securityMode value
     * @return string
     */
    public function getSecurityMode()
    {
        return $this->securityMode;
    }
    /**
     * Set securityMode value
     * @param string $securityMode
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCumaServerSecurityProfile
     */
    public function setSecurityMode($securityMode = null)
    {
        $this->securityMode = $securityMode;
        return $this;
    }
    /**
     * Get transportType value
     * @return string
     */
    public function getTransportType()
    {
        return $this->transportType;
    }
    /**
     * Set transportType value
     * @param string $transportType
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCumaServerSecurityProfile
     */
    public function setTransportType($transportType = 'TCP+UDP')
    {
        $this->transportType = $transportType;
        return $this;
    }
    /**
     * Get serverIpHostName value
     * @return string
     */
    public function getServerIpHostName()
    {
        return $this->serverIpHostName;
    }
    /**
     * Set serverIpHostName value
     * @param string $serverIpHostName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCumaServerSecurityProfile
     */
    public function setServerIpHostName($serverIpHostName = null)
    {
        $this->serverIpHostName = $serverIpHostName;
        return $this;
    }
    /**
     * Get description value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescription()
    {
        return isset($this->description) ? $this->description : null;
    }
    /**
     * Set description value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCumaServerSecurityProfile
     */
    public function setDescription($description = null)
    {
        if (is_null($description) || (is_array($description) && empty($description))) {
            unset($this->description);
        } else {
            $this->description = $description;
        }
        return $this;
    }
    /**
     * Get x509SubjectName value
     * @return string|null
     */
    public function getX509SubjectName()
    {
        return $this->x509SubjectName;
    }
    /**
     * Set x509SubjectName value
     * @param string $x509SubjectName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCumaServerSecurityProfile
     */
    public function setX509SubjectName($x509SubjectName = null)
    {
        $this->x509SubjectName = $x509SubjectName;
        return $this;
    }
}
